VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{D40CB43F-93E5-419F-BF4E-CB0DFC9E6C6D}#1.0#0"; "LinkedNodeCtl.ocx"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "DFA"
   ClientHeight    =   5550
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6570
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5550
   ScaleWidth      =   6570
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog dlgOpen 
      Left            =   600
      Top             =   4800
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox txtSleepTime 
      Height          =   315
      Left            =   2340
      TabIndex        =   5
      Text            =   "200"
      Top             =   300
      Width           =   495
   End
   Begin LinkedNodeCtl.LinkedNodeView LinkedNodeView1 
      Height          =   3075
      Left            =   1380
      TabIndex        =   3
      Top             =   2340
      Width           =   4995
      _ExtentX        =   8811
      _ExtentY        =   5424
      SnapToGrid      =   0   'False
      ShowImageSelect =   0   'False
      ShowLabelSelect =   0   'False
      GridSize        =   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Appearance      =   0
      OLEDropMode     =   0
      ScaleHeight     =   3075
      ScaleMode       =   0
      ScaleWidth      =   4995
   End
   Begin MSComctlLib.ImageList imlImages 
      Left            =   60
      Top             =   4740
      _ExtentX        =   1005
      _ExtentY        =   1005
      BackColor       =   -2147483643
      ImageWidth      =   16
      ImageHeight     =   16
      MaskColor       =   12632256
      _Version        =   393216
      BeginProperty Images {2C247F25-8591-11D1-B16A-00C0F0283628} 
         NumListImages   =   2
         BeginProperty ListImage1 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":0000
            Key             =   "idle"
         EndProperty
         BeginProperty ListImage2 {2C247F27-8591-11D1-B16A-00C0F0283628} 
            Picture         =   "frmMain.frx":0452
            Key             =   "processing"
         EndProperty
      EndProperty
   End
   Begin VB.TextBox txtData 
      Height          =   1155
      HideSelection   =   0   'False
      Left            =   1440
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Text            =   "frmMain.frx":08A4
      Top             =   780
      Width           =   4755
   End
   Begin VB.CommandButton cmdRun 
      Caption         =   "Run"
      Height          =   435
      Left            =   1200
      TabIndex        =   1
      Top             =   180
      Width           =   1005
   End
   Begin VB.CommandButton cmdLoad 
      Caption         =   "Load"
      Height          =   435
      Left            =   210
      TabIndex        =   0
      Top             =   180
      Width           =   915
   End
   Begin VB.Label Label3 
      Caption         =   "Enter as much data here as you want"
      Height          =   855
      Left            =   240
      TabIndex        =   8
      Top             =   840
      Width           =   1155
   End
   Begin VB.Label Label2 
      Caption         =   "After you have loaded a program you can drag the nodes around to see a diagram of the automaton"
      Height          =   1815
      Left            =   240
      TabIndex        =   7
      Top             =   2820
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Delay"
      Height          =   195
      Left            =   2340
      TabIndex        =   6
      Top             =   120
      Width           =   495
   End
   Begin VB.Label lblStatus 
      Height          =   225
      Left            =   1440
      TabIndex        =   4
      Top             =   2100
      Width           =   1605
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Sub Sleep Lib "kernel32" (ByVal Milliseconds As Long)

Private WithEvents m_objAutomaton As Automaton
Attribute m_objAutomaton.VB_VarHelpID = -1
Private WithEvents m_objCurrentState As State
Attribute m_objCurrentState.VB_VarHelpID = -1
'
'
'

Private Sub cmdLoad_Click()
    Dim objInstruction As Instruction
    Dim objState As State
    Dim lngCount As Long
    Dim lngFile As Long
    Dim strCommand As String
    
    'Locate a file to open
    dlgOpen.ShowOpen
    If dlgOpen.FileName <> "" Then
        Set m_objAutomaton = New Automaton
        lngFile = FreeFile
        Open dlgOpen.FileName For Input As lngFile
            Do Until EOF(lngFile)
                Line Input #lngFile, strCommand
                 m_objAutomaton.DefineState strCommand
            Loop
        Close lngFile
    End If
    
    'Display Linked nodes
    'States
    For lngCount = 1 To LinkedNodeView1.Nodes.Count
        LinkedNodeView1.Nodes.Remove 1
    Next
    Set LinkedNodeView1.ImageList = imlImages
    For Each objState In m_objAutomaton.States
        LinkedNodeView1.Nodes.Add objState.StateId, "State " & objState.StateId, , "idle"
    Next
    
    'Instructions
    For Each objState In m_objAutomaton.States
        For Each objInstruction In objState.Instructions
            LinkedNodeView1.Nodes(objState.StateId).Links.Add objInstruction.DataIn, LinkedNodeView1.Nodes(objInstruction.NewState), dir_Forward
        Next
    Next
    LinkedNodeView1.Refresh
End Sub

Private Sub cmdRun_Click()
    Dim strElement As String
    Dim lngHead As Long
    Dim strDataStream As String
    Dim strNewValue As String
    Dim strDirection As String
    
    lblStatus.Caption = "Running..."
    Me.Refresh
    If m_objAutomaton Is Nothing Then
        MsgBox "Automaton not loaded."
    Else
        'Runs through the data
        'Initialise the Automaton
        m_objAutomaton.Reset
        lngHead = 0
        strDataStream = txtData.Text
        
        Do Until lngHead < 0
            'Read the element under the head
            strElement = Mid(strDataStream, lngHead + 1, 1)
            
            Set m_objCurrentState = m_objAutomaton.CurrentState
            
            If m_objAutomaton.Evaluate(strElement, strNewValue, strDirection) Then
                Mid(strDataStream, lngHead + 1, 1) = strNewValue
                
                'Display the progress
                txtData.Refresh
                txtData.Text = strDataStream
                txtData.SelStart = lngHead
                txtData.SelLength = 1
                
                'Move the head
                lngHead = lngHead + IIf(strDirection = "L", -1, 1)
            Else
                MsgBox "There has been a processing error."
                Exit Do
            End If
            
            'Wait
            If IsNumeric(txtSleepTime.Text) Then
                Sleep txtSleepTime.Text
            End If
        Loop
        txtData.SelStart = 0
        txtData.SelLength = 0
        lblStatus.Caption = "Done"
    End If
End Sub

Private Sub m_objAutomaton_ChangeState(ByVal OldState As State, ByVal NewState As State)
    If Not OldState Is Nothing Then
        LinkedNodeView1.Nodes(OldState.StateId).ImageKey = "idle"
    End If
    LinkedNodeView1.Nodes(NewState.StateId).ImageKey = "processing"
End Sub

